{% extends "base.html.twig" %}



{% block content %}
    <div class="containter mt-4">
        <div class="row justify-content-center">
            <div class="col-lg-9 col-12 card mb-4 pb-4">
                <div class="card-title">Filters</div>
                <div class="card-body p-0">
                    <div>
                        <label for="filter_category" class="form-label">Category</label>
                        <select class="form-select" aria-label="Default select example" id="filter_category">
                            <option value="0">No category</option>
                            {% for key, category in products.categories.list %}
                                <option value="{{ category }}" {% if products.filter.category==category %} selected {% endif %}>{{ category }}</option>
                            {% endfor %}
                        </select>
                    </div>
                    <div class="mt-3">
                        <label for="filter_min-weight" class="form-label">Min weight (gramms)</label>
                        <input type="text" class="form-control" id="filter_min-weight" placeholder="0" value="{{ products.filter.minWeight }}">
                    </div>
                    <div class="mt-3">
                        <label for="filter_max-weight" class="form-label">Max weight (gramms)</label>
                        <input type="text" class="form-control" id="filter_max-weight" placeholder="1000" value="{{ products.filter.maxWeight }}">
                    </div>
                    <button type="submit" class="btn btn-primary mt-3" id="submitFilter">Submit</button>
                </div>
            </div>

            <!-- TODO: Refactor table header-->
            <div class="col-lg-9 col-12 card">
                <div class="card-body p-0">
                    <div class="row mt-4 justify-content-end">
                        <div class="col">
                            <nav aria-label="Page navigation example">
                                <ul class="pagination">
                                    {% if products.pages.showMin > 1 %}
                                        <li class="page-item"><a class="page-link" href="{{ path(app.request.attributes.get('_route'),
                                                app.request.query.all|merge({'page': 1})) }}">1</a></li>
                                        <li class="page-item"><a class="page-link disabled">..</a></li>

                                    {% endif%}
                                    {%  for page in products.pages.showMin..products.pages.showMax %}
                                        <li class="page-item  {%if page == products.filter.page %} active{% endif %}"><a class="page-link" href="{{ path(app.request.attributes.get('_route'),
                                                app.request.query.all|merge({'page': page})) }}">{{ page }}</a></li>
                                    {% endfor %}

                                    {% if products.pages.showMax < products.pages.total %}
                                        <li class="page-item"><a class="page-link disabled">..</a></li>
                                        <li class="page-item"><a class="page-link" href="{{ path(app.request.attributes.get('_route'),
                                                app.request.query.all|merge({'page': products.pages.total})) }}">{{ products.pages.total }}</a></li>
                                    {% endif%}
                                </ul>
                            </nav>
                        </div>
                        <div class="col-2">
                            <select class="form-select" aria-label="Default select example" id="items-per-page">
                                <option value="50">Items per page</option>
                                <option value="50" {% if products.filter.limit==50 %} selected {% endif %}>50</option>
                                <option value="100" {% if products.filter.limit==100 %} selected {% endif %}>100</option>
                                <option value="500" {% if products.filter.limit==500 %} selected {% endif %}>500</option>
                            </select>
                        </div>
                    </div>
                    <table class="table table-hover">
                        <thead>
                        <tr>
                            <th scope="col">
                                <a href="{{ path(app.request.attributes.get('_route'),
                                    app.request.query.all|merge({'orderBy': 'name', 'order':
                                        products.filter.orderBy == 'name' ?
                                        (products.filter.order == 'desc' ? 'asc' : 'desc') :
                                        products.filter.order

                                    })) }}">Name</a>
                                {% if products.filter.orderBy == 'name' %}
                                    {% if products.filter.order == 'asc' %}
                                        <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-sort-down-alt" viewBox="0 0 16 16">
                                            <path d="M3.5 3.5a.5.5 0 0 0-1 0v8.793l-1.146-1.147a.5.5 0 0 0-.708.708l2 1.999.007.007a.497.497 0 0 0 .7-.006l2-2a.5.5 0 0 0-.707-.708L3.5 12.293V3.5zm4 .5a.5.5 0 0 1 0-1h1a.5.5 0 0 1 0 1h-1zm0 3a.5.5 0 0 1 0-1h3a.5.5 0 0 1 0 1h-3zm0 3a.5.5 0 0 1 0-1h5a.5.5 0 0 1 0 1h-5zM7 12.5a.5.5 0 0 0 .5.5h7a.5.5 0 0 0 0-1h-7a.5.5 0 0 0-.5.5z"/>
                                        </svg>
                                    {% else %}
                                        <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-sort-down" viewBox="0 0 16 16">
                                            <path d="M3.5 2.5a.5.5 0 0 0-1 0v8.793l-1.146-1.147a.5.5 0 0 0-.708.708l2 1.999.007.007a.497.497 0 0 0 .7-.006l2-2a.5.5 0 0 0-.707-.708L3.5 11.293V2.5zm3.5 1a.5.5 0 0 1 .5-.5h7a.5.5 0 0 1 0 1h-7a.5.5 0 0 1-.5-.5zM7.5 6a.5.5 0 0 0 0 1h5a.5.5 0 0 0 0-1h-5zm0 3a.5.5 0 0 0 0 1h3a.5.5 0 0 0 0-1h-3zm0 3a.5.5 0 0 0 0 1h1a.5.5 0 0 0 0-1h-1z"/>
                                        </svg>
                                    {% endif %}
                                {% endif %}
                            </th>
                            <th scope="col">
                                <a href="{{ path(app.request.attributes.get('_route'),
                                    app.request.query.all|merge({'orderBy': 'description', 'order':
                                        products.filter.orderBy == 'description' ?
                                        (products.filter.order == 'desc' ? 'asc' : 'desc') :
                                        products.filter.order

                                    })) }}">Description</a>
                                {% if products.filter.orderBy == 'description' %}
                                    {% if products.filter.order == 'asc' %}
                                        <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-sort-down-alt" viewBox="0 0 16 16">
                                            <path d="M3.5 3.5a.5.5 0 0 0-1 0v8.793l-1.146-1.147a.5.5 0 0 0-.708.708l2 1.999.007.007a.497.497 0 0 0 .7-.006l2-2a.5.5 0 0 0-.707-.708L3.5 12.293V3.5zm4 .5a.5.5 0 0 1 0-1h1a.5.5 0 0 1 0 1h-1zm0 3a.5.5 0 0 1 0-1h3a.5.5 0 0 1 0 1h-3zm0 3a.5.5 0 0 1 0-1h5a.5.5 0 0 1 0 1h-5zM7 12.5a.5.5 0 0 0 .5.5h7a.5.5 0 0 0 0-1h-7a.5.5 0 0 0-.5.5z"/>
                                        </svg>
                                    {% else %}
                                        <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-sort-down" viewBox="0 0 16 16">
                                            <path d="M3.5 2.5a.5.5 0 0 0-1 0v8.793l-1.146-1.147a.5.5 0 0 0-.708.708l2 1.999.007.007a.497.497 0 0 0 .7-.006l2-2a.5.5 0 0 0-.707-.708L3.5 11.293V2.5zm3.5 1a.5.5 0 0 1 .5-.5h7a.5.5 0 0 1 0 1h-7a.5.5 0 0 1-.5-.5zM7.5 6a.5.5 0 0 0 0 1h5a.5.5 0 0 0 0-1h-5zm0 3a.5.5 0 0 0 0 1h3a.5.5 0 0 0 0-1h-3zm0 3a.5.5 0 0 0 0 1h1a.5.5 0 0 0 0-1h-1z"/>
                                        </svg>
                                    {% endif %}
                                {% endif %}
                            </th>
                            <th scope="col">
                                <a href="{{ path(app.request.attributes.get('_route'),
                                    app.request.query.all|merge({'orderBy': 'weight', 'order':
                                        products.filter.orderBy == 'weight' ?
                                        (products.filter.order == 'desc' ? 'asc' : 'desc') :
                                        products.filter.order

                                    })) }}">Weight</a>
                                {% if products.filter.orderBy == 'weight' %}
                                    {% if products.filter.order == 'asc' %}
                                        <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-sort-down-alt" viewBox="0 0 16 16">
                                            <path d="M3.5 3.5a.5.5 0 0 0-1 0v8.793l-1.146-1.147a.5.5 0 0 0-.708.708l2 1.999.007.007a.497.497 0 0 0 .7-.006l2-2a.5.5 0 0 0-.707-.708L3.5 12.293V3.5zm4 .5a.5.5 0 0 1 0-1h1a.5.5 0 0 1 0 1h-1zm0 3a.5.5 0 0 1 0-1h3a.5.5 0 0 1 0 1h-3zm0 3a.5.5 0 0 1 0-1h5a.5.5 0 0 1 0 1h-5zM7 12.5a.5.5 0 0 0 .5.5h7a.5.5 0 0 0 0-1h-7a.5.5 0 0 0-.5.5z"/>
                                        </svg>
                                    {% else %}
                                        <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-sort-down" viewBox="0 0 16 16">
                                            <path d="M3.5 2.5a.5.5 0 0 0-1 0v8.793l-1.146-1.147a.5.5 0 0 0-.708.708l2 1.999.007.007a.497.497 0 0 0 .7-.006l2-2a.5.5 0 0 0-.707-.708L3.5 11.293V2.5zm3.5 1a.5.5 0 0 1 .5-.5h7a.5.5 0 0 1 0 1h-7a.5.5 0 0 1-.5-.5zM7.5 6a.5.5 0 0 0 0 1h5a.5.5 0 0 0 0-1h-5zm0 3a.5.5 0 0 0 0 1h3a.5.5 0 0 0 0-1h-3zm0 3a.5.5 0 0 0 0 1h1a.5.5 0 0 0 0-1h-1z"/>
                                        </svg>
                                    {% endif %}
                                {% endif %}
                            </th>
                            <th scope="col">
                                <a href="{{ path(app.request.attributes.get('_route'),
                                    app.request.query.all|merge({'orderBy': 'category', 'order':
                                        products.filter.orderBy == 'category' ?
                                        (products.filter.order == 'desc' ? 'asc' : 'desc') :
                                        products.filter.order

                                    })) }}">Category</a>
                                {% if products.filter.orderBy == 'category' %}
                                    {% if products.filter.order == 'asc' %}
                                        <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-sort-down-alt" viewBox="0 0 16 16">
                                            <path d="M3.5 3.5a.5.5 0 0 0-1 0v8.793l-1.146-1.147a.5.5 0 0 0-.708.708l2 1.999.007.007a.497.497 0 0 0 .7-.006l2-2a.5.5 0 0 0-.707-.708L3.5 12.293V3.5zm4 .5a.5.5 0 0 1 0-1h1a.5.5 0 0 1 0 1h-1zm0 3a.5.5 0 0 1 0-1h3a.5.5 0 0 1 0 1h-3zm0 3a.5.5 0 0 1 0-1h5a.5.5 0 0 1 0 1h-5zM7 12.5a.5.5 0 0 0 .5.5h7a.5.5 0 0 0 0-1h-7a.5.5 0 0 0-.5.5z"/>
                                        </svg>
                                    {% else %}
                                        <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-sort-down" viewBox="0 0 16 16">
                                            <path d="M3.5 2.5a.5.5 0 0 0-1 0v8.793l-1.146-1.147a.5.5 0 0 0-.708.708l2 1.999.007.007a.497.497 0 0 0 .7-.006l2-2a.5.5 0 0 0-.707-.708L3.5 11.293V2.5zm3.5 1a.5.5 0 0 1 .5-.5h7a.5.5 0 0 1 0 1h-7a.5.5 0 0 1-.5-.5zM7.5 6a.5.5 0 0 0 0 1h5a.5.5 0 0 0 0-1h-5zm0 3a.5.5 0 0 0 0 1h3a.5.5 0 0 0 0-1h-3zm0 3a.5.5 0 0 0 0 1h1a.5.5 0 0 0 0-1h-1z"/>
                                        </svg>
                                    {% endif %}
                                {% endif %}
                            </th>
                        </tr>
                        </thead>
                        {% for key, product in products.list %}
                            <tr data-product-id="{{ product.id }}">
                                <td>{{ product.name }}</td>
                                <td>{{ product.description }}</td>
                                <td>{{ product.weight }}</td>
                                <td>{{ product.category }}</td>
                            </tr>
                        {% endfor %}
                    </table>
                </div>
            </div>
        </div>
    </div>
    <script>
        document.getElementById('items-per-page').onchange = function() {
            let url = new URL(window.location.href)
            let search_params = url.searchParams;
            search_params.set('limit', this.value);
            search_params.set('page', 1);
            url.search = search_params.toString();
            window.location = url.toString()
        };
        // document.getElementById('filter_category').onchange = function() {
        //     let url = new URL(window.location.href)
        //     let search_params = url.searchParams;
        //     search_params.set('category', this.value);
        //     url.search = search_params.toString();
        //     window.location = url.toString()
        // };
        document.getElementById('submitFilter').onclick = function() {
            let url = new URL(window.location.href)
            let search_params = url.searchParams;
            search_params.set('category', document.getElementById('filter_category').value);
            search_params.set('minWeight', document.getElementById('filter_min-weight').value);
            search_params.set('maxWeight', document.getElementById('filter_max-weight').value);
            search_params.set('page', '1');
            url.search = search_params.toString();
            window.location = url.toString()
        };
    </script>
{% endblock %}